<?php

namespace Frontdesk\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfFaultException.FaultCodeData ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfFaultException.FaultCodeData
 * @subpackage Arrays
 */
class ArrayOfFaultException_FaultCodeData extends AbstractStructArrayBase
{
    /**
     * The FaultException_FaultCodeData
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \Frontdesk\StructType\FaultException_FaultCodeData[]
     */
    public $FaultException_FaultCodeData;
    /**
     * Constructor method for ArrayOfFaultException.FaultCodeData
     * @uses ArrayOfFaultException_FaultCodeData::setFaultException_FaultCodeData()
     * @param \Frontdesk\StructType\FaultException_FaultCodeData[] $faultException_FaultCodeData
     */
    public function __construct(array $faultException_FaultCodeData = array())
    {
        $this
            ->setFaultException_FaultCodeData($faultException_FaultCodeData);
    }
    /**
     * Get FaultException_FaultCodeData value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Frontdesk\StructType\FaultException_FaultCodeData[]|null
     */
    public function getFaultException_FaultCodeData()
    {
        return isset($this->{'FaultException.FaultCodeData'}) ? $this->{'FaultException.FaultCodeData'} : null;
    }
    /**
     * This method is responsible for validating the values passed to the setFaultException_FaultCodeData method
     * This method is willingly generated in order to preserve the one-line inline validation within the setFaultException_FaultCodeData method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateFaultException_FaultCodeDataForArrayConstraintsFromSetFaultException_FaultCodeData(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfFaultException_FaultCodeDataFaultException_FaultCodeDataItem) {
            // validation for constraint: itemType
            if (!$arrayOfFaultException_FaultCodeDataFaultException_FaultCodeDataItem instanceof \Frontdesk\StructType\FaultException_FaultCodeData) {
                $invalidValues[] = is_object($arrayOfFaultException_FaultCodeDataFaultException_FaultCodeDataItem) ? get_class($arrayOfFaultException_FaultCodeDataFaultException_FaultCodeDataItem) : sprintf('%s(%s)', gettype($arrayOfFaultException_FaultCodeDataFaultException_FaultCodeDataItem), var_export($arrayOfFaultException_FaultCodeDataFaultException_FaultCodeDataItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The FaultException_FaultCodeData property can only contain items of type \Frontdesk\StructType\FaultException_FaultCodeData, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set FaultException_FaultCodeData value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \Frontdesk\StructType\FaultException_FaultCodeData[] $faultException_FaultCodeData
     * @return \Frontdesk\ArrayType\ArrayOfFaultException_FaultCodeData
     */
    public function setFaultException_FaultCodeData(array $faultException_FaultCodeData = array())
    {
        // validation for constraint: array
        if ('' !== ($faultException_FaultCodeDataArrayErrorMessage = self::validateFaultException_FaultCodeDataForArrayConstraintsFromSetFaultException_FaultCodeData($faultException_FaultCodeData))) {
            throw new \InvalidArgumentException($faultException_FaultCodeDataArrayErrorMessage, __LINE__);
        }
        if (is_null($faultException_FaultCodeData) || (is_array($faultException_FaultCodeData) && empty($faultException_FaultCodeData))) {
            unset($this->FaultException_FaultCodeData, $this->{'FaultException.FaultCodeData'});
        } else {
            $this->FaultException_FaultCodeData = $this->{'FaultException.FaultCodeData'} = $faultException_FaultCodeData;
        }
        return $this;
    }
    /**
     * Add item to FaultException_FaultCodeData value
     * @throws \InvalidArgumentException
     * @param \Frontdesk\StructType\FaultException_FaultCodeData $item
     * @return \Frontdesk\ArrayType\ArrayOfFaultException_FaultCodeData
     */
    public function addToFaultException_FaultCodeData(\Frontdesk\StructType\FaultException_FaultCodeData $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Frontdesk\StructType\FaultException_FaultCodeData) {
            throw new \InvalidArgumentException(sprintf('The FaultException_FaultCodeData property can only contain items of type \Frontdesk\StructType\FaultException_FaultCodeData, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->FaultException_FaultCodeData[] = $this->{'FaultException.FaultCodeData'}[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \Frontdesk\StructType\FaultException_FaultCodeData|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \Frontdesk\StructType\FaultException_FaultCodeData|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \Frontdesk\StructType\FaultException_FaultCodeData|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \Frontdesk\StructType\FaultException_FaultCodeData|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \Frontdesk\StructType\FaultException_FaultCodeData|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string FaultException.FaultCodeData
     */
    public function getAttributeName()
    {
        return 'FaultException.FaultCodeData';
    }
}
