<?php

namespace Frontdesk\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfFaultException.FaultReasonData ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfFaultException.FaultReasonData
 * @subpackage Arrays
 */
class ArrayOfFaultException_FaultReasonData extends AbstractStructArrayBase
{
    /**
     * The FaultException_FaultReasonData
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \Frontdesk\StructType\FaultException_FaultReasonData[]
     */
    public $FaultException_FaultReasonData;
    /**
     * Constructor method for ArrayOfFaultException.FaultReasonData
     * @uses ArrayOfFaultException_FaultReasonData::setFaultException_FaultReasonData()
     * @param \Frontdesk\StructType\FaultException_FaultReasonData[] $faultException_FaultReasonData
     */
    public function __construct(array $faultException_FaultReasonData = array())
    {
        $this
            ->setFaultException_FaultReasonData($faultException_FaultReasonData);
    }
    /**
     * Get FaultException_FaultReasonData value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Frontdesk\StructType\FaultException_FaultReasonData[]|null
     */
    public function getFaultException_FaultReasonData()
    {
        return isset($this->{'FaultException.FaultReasonData'}) ? $this->{'FaultException.FaultReasonData'} : null;
    }
    /**
     * This method is responsible for validating the values passed to the setFaultException_FaultReasonData method
     * This method is willingly generated in order to preserve the one-line inline validation within the setFaultException_FaultReasonData method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateFaultException_FaultReasonDataForArrayConstraintsFromSetFaultException_FaultReasonData(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfFaultException_FaultReasonDataFaultException_FaultReasonDataItem) {
            // validation for constraint: itemType
            if (!$arrayOfFaultException_FaultReasonDataFaultException_FaultReasonDataItem instanceof \Frontdesk\StructType\FaultException_FaultReasonData) {
                $invalidValues[] = is_object($arrayOfFaultException_FaultReasonDataFaultException_FaultReasonDataItem) ? get_class($arrayOfFaultException_FaultReasonDataFaultException_FaultReasonDataItem) : sprintf('%s(%s)', gettype($arrayOfFaultException_FaultReasonDataFaultException_FaultReasonDataItem), var_export($arrayOfFaultException_FaultReasonDataFaultException_FaultReasonDataItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The FaultException_FaultReasonData property can only contain items of type \Frontdesk\StructType\FaultException_FaultReasonData, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set FaultException_FaultReasonData value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \Frontdesk\StructType\FaultException_FaultReasonData[] $faultException_FaultReasonData
     * @return \Frontdesk\ArrayType\ArrayOfFaultException_FaultReasonData
     */
    public function setFaultException_FaultReasonData(array $faultException_FaultReasonData = array())
    {
        // validation for constraint: array
        if ('' !== ($faultException_FaultReasonDataArrayErrorMessage = self::validateFaultException_FaultReasonDataForArrayConstraintsFromSetFaultException_FaultReasonData($faultException_FaultReasonData))) {
            throw new \InvalidArgumentException($faultException_FaultReasonDataArrayErrorMessage, __LINE__);
        }
        if (is_null($faultException_FaultReasonData) || (is_array($faultException_FaultReasonData) && empty($faultException_FaultReasonData))) {
            unset($this->FaultException_FaultReasonData, $this->{'FaultException.FaultReasonData'});
        } else {
            $this->FaultException_FaultReasonData = $this->{'FaultException.FaultReasonData'} = $faultException_FaultReasonData;
        }
        return $this;
    }
    /**
     * Add item to FaultException_FaultReasonData value
     * @throws \InvalidArgumentException
     * @param \Frontdesk\StructType\FaultException_FaultReasonData $item
     * @return \Frontdesk\ArrayType\ArrayOfFaultException_FaultReasonData
     */
    public function addToFaultException_FaultReasonData(\Frontdesk\StructType\FaultException_FaultReasonData $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Frontdesk\StructType\FaultException_FaultReasonData) {
            throw new \InvalidArgumentException(sprintf('The FaultException_FaultReasonData property can only contain items of type \Frontdesk\StructType\FaultException_FaultReasonData, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->FaultException_FaultReasonData[] = $this->{'FaultException.FaultReasonData'}[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \Frontdesk\StructType\FaultException_FaultReasonData|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \Frontdesk\StructType\FaultException_FaultReasonData|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \Frontdesk\StructType\FaultException_FaultReasonData|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \Frontdesk\StructType\FaultException_FaultReasonData|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \Frontdesk\StructType\FaultException_FaultReasonData|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string FaultException.FaultReasonData
     */
    public function getAttributeName()
    {
        return 'FaultException.FaultReasonData';
    }
}
