<?php

namespace Frontdesk;

/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'ClientRequestModel' => '\\Frontdesk\\StructType\\ClientRequestModel',
            'ClientResponseModel' => '\\Frontdesk\\StructType\\ClientResponseModel',
            'ClientRequestModel2' => '\\Frontdesk\\StructType\\ClientRequestModel2',
            'ClientResponseModel2' => '\\Frontdesk\\StructType\\ClientResponseModel2',
            'EntryPageFunctionality' => '\\Frontdesk\\StructType\\EntryPageFunctionality',
            'EntryPageFunctionalityResponse' => '\\Frontdesk\\StructType\\EntryPageFunctionalityResponse',
            'EntryPageFunctionalityV2' => '\\Frontdesk\\StructType\\EntryPageFunctionalityV2',
            'EntryPageFunctionalityV2Response' => '\\Frontdesk\\StructType\\EntryPageFunctionalityV2Response',
            'SystemException' => '\\Frontdesk\\StructType\\SystemException',
            'Exception' => '\\Frontdesk\\StructType\\Exception',
            'FaultException' => '\\Frontdesk\\StructType\\FaultException',
            'CommunicationException' => '\\Frontdesk\\StructType\\CommunicationException',
            'FaultException.FaultCodeData' => '\\Frontdesk\\StructType\\FaultException_FaultCodeData',
            'ArrayOfFaultException.FaultCodeData' => '\\Frontdesk\\ArrayType\\ArrayOfFaultException_FaultCodeData',
            'FaultException.FaultReasonData' => '\\Frontdesk\\StructType\\FaultException_FaultReasonData',
            'ArrayOfFaultException.FaultReasonData' => '\\Frontdesk\\ArrayType\\ArrayOfFaultException_FaultReasonData',
        );
    }
}
