<?php

namespace Frontdesk\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for FaultException.FaultReasonData StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:FaultException.FaultReasonData
 * @subpackage Structs
 */
class FaultException_FaultReasonData extends AbstractStructBase
{
    /**
     * The text
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $text;
    /**
     * The xmlLang
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $xmlLang;
    /**
     * Constructor method for FaultException.FaultReasonData
     * @uses FaultException_FaultReasonData::setText()
     * @uses FaultException_FaultReasonData::setXmlLang()
     * @param string $text
     * @param string $xmlLang
     */
    public function __construct($text = null, $xmlLang = null)
    {
        $this
            ->setText($text)
            ->setXmlLang($xmlLang);
    }
    /**
     * Get text value
     * @return string|null
     */
    public function getText()
    {
        return $this->text;
    }
    /**
     * Set text value
     * @param string $text
     * @return \Frontdesk\StructType\FaultException_FaultReasonData
     */
    public function setText($text = null)
    {
        // validation for constraint: string
        if (!is_null($text) && !is_string($text)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($text, true), gettype($text)), __LINE__);
        }
        $this->text = $text;
        return $this;
    }
    /**
     * Get xmlLang value
     * @return string|null
     */
    public function getXmlLang()
    {
        return $this->xmlLang;
    }
    /**
     * Set xmlLang value
     * @param string $xmlLang
     * @return \Frontdesk\StructType\FaultException_FaultReasonData
     */
    public function setXmlLang($xmlLang = null)
    {
        // validation for constraint: string
        if (!is_null($xmlLang) && !is_string($xmlLang)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($xmlLang, true), gettype($xmlLang)), __LINE__);
        }
        $this->xmlLang = $xmlLang;
        return $this;
    }
}
